/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#ifndef MIRAI_BASE_FILE_RESOURCE_H
#define MIRAI_BASE_FILE_RESOURCE_H

#include "BaseResource.h"
#include <string>

namespace mirai
{

struct BaseFileResourceConstructor {
	std::string name;
	std::string path;
};

class BaseFileResource : public BaseResource
{
  public:
	BaseFileResource(BaseFileResourceConstructor data)
		: BaseResource(data.name), path(data.path) {};

	BaseFileResource(BaseFileResource &) = delete;
	BaseFileResource(BaseFileResource &&) = delete;
	~BaseFileResource() override = default;

	const std::string &getPath() const
	{
		return path;
	}

  private:
	std::string path;
};
} // namespace mirai
#endif
